<script lang="ts">
  import { type Environment, type EventSettings, GetEventSettings, updateEnvironment } from '@models/EventSettings';
  import SummaryTable from '@components/ServiceScoring/SummaryTable.svelte';
  import { eventId } from '@stores';
  import LabeledContainer from '@components/LabeledContainer.svelte';
  import EditMarkdown from '@components/Markdown/EditMarkdown.svelte';

  type SettingsReturn = {
    settings: EventSettings | null;
    env: Environment | null;
  };

  $: eventSettings = getSettings($eventId);

  async function getSettings(id: string): Promise<SettingsReturn> {
    // extract environment info from array
    const ret: SettingsReturn = {
      settings: await GetEventSettings(id),
      env: null,
    };
    if (ret.settings?.event?.environments?.length) {
      ret.env = ret.settings.event.environments[0];
    }
    return ret;
  }

  async function saveEnvironmentInfo(name: string, info: string) {
    await updateEnvironment({ name, info });
  }
</script>

{#await eventSettings}
  <p>Loading...</p>
{:then ev}
  <div class="row pb-4">
    <div class="col-12">
      <LabeledContainer label="Infrastructure Services" borderColor="white">
        <div class="p-3">
          <h4>Click on a table row to view more details about the service</h4>
          <SummaryTable edit />
        </div>
      </LabeledContainer>
    </div>
    <div class="col-12">
      {#if ev.env}
        <h3>Edit <b>{ev.env.name}</b> Environment Info</h3>
        <EditMarkdown
          minHeight="80vh"
          multiline
          text={ev.env.info || ''}
          on:save={(e) => saveEnvironmentInfo(ev.env.name, e.detail)}
        />
      {/if}
    </div>
  </div>
{:catch e}
  <h1>Event not found!</h1>
{/await}
